﻿using Aliyun.Acs.Core;
using Aliyun.Acs.Core.Profile;
using Aliyun.Acs.vod.Model.V20170321;
using Aliyun.OSS;
using Aliyun.OSS.Common;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace robot
{
    /// <summary>
    /// 处理视频上传
    /// </summary>
    public class VodHelper
    {
        public DefaultAcsClient acsClient = null;

        public VodHelper() 
        {
            string regionId = "cn-shanghai";
            IClientProfile profile = DefaultProfile.GetProfile(regionId, "LTAI5tBoku6yPFSkacA3sbAT", "zcjzTpMGyPwchaKAyUFeKNEBcqAxvL");
            // DefaultProfile.AddEndpoint(regionId, regionId, "vod", "vod." + regionId + ".aliyuncs.com");
            acsClient = new DefaultAcsClient(profile);
        }

        #region 服务端方法

        public void UploadVod() 
        {
            CreateUploadVideoRequest request = new CreateUploadVideoRequest();
            request.Title = "this is a sample title";
            request.FileName = "sample.mp4";
            // request.Tags = "tags1,tags2";
            // request.Description = "this is a sample description";
            // request.CoverURL = "http://192.168.0.0/16/sample.jpg";
            // request.CateId = -1;
            // request.TemplateGroupId = "278840921dee4963bb5862b43a52****";
            // 初始化客户端
            // 发起请求，并得到响应结果
            CreateUploadVideoResponse response = acsClient.GetAcsResponse(request);
            Console.WriteLine("RequestId = " + response.RequestId);
            Console.WriteLine("UploadAddress = " + response.UploadAddress);
            Console.WriteLine("UploadAuth = " + response.UploadAuth);
        }
        public VideoRequest CreateUploadVideo(string strTitle, string strFileName)
        {
            CreateUploadVideoRequest request = new CreateUploadVideoRequest();
            request.FileName = strFileName;
            request.Title = strTitle;
            
            CreateUploadVideoResponse response = acsClient.GetAcsResponse(request);
            VideoRequest obj = new VideoRequest();
            obj.RequestId = response.RequestId;
            obj.UploadAddress = Base64Decode(response.UploadAddress);
            obj.UploadAuth = Base64Decode(response.UploadAuth);
            obj.VideoId = response.VideoId;
            return obj;
        }

        public void GetVideoStatis(string strVid)
        {
            DescribePlayVideoStatisRequest request = new DescribePlayVideoStatisRequest();
            request.StartTime = "";
            request.EndTime = "";
            request.VideoId = "";
            
            DescribePlayVideoStatisResponse response = acsClient.GetAcsResponse(request);
        }

        public string GetPlayInfo(string strVid)
        {
            try
            {
                GetPlayInfoRequest request = new GetPlayInfoRequest();
                string strAliVid = strVid;//this.GetAliVid(strVid);
                if (string.IsNullOrEmpty(strAliVid))
                {
                    return string.Empty;
                }
                request.VideoId = strAliVid;
                
                GetPlayInfoResponse response = acsClient.GetAcsResponse(request);
                List<GetPlayInfoResponse.GetPlayInfo_PlayInfo> playInfoList = response.PlayInfoList;
                if (playInfoList.Count > 0)
                {
                    return playInfoList[0].PlayURL;
                }
                return string.Empty;
            }
            catch (Exception ex)
            {
                return string.Empty;
                throw;
            }
        }
        public string GetHRPlayInfo(string strVid)
        {
            try
            {
                GetPlayInfoRequest request = new GetPlayInfoRequest();
                request.VideoId = strVid;
                
                GetPlayInfoResponse response = acsClient.GetAcsResponse(request);
                List<GetPlayInfoResponse.GetPlayInfo_PlayInfo> playInfoList = response.PlayInfoList;
                if (playInfoList.Count > 0)
                {
                    return playInfoList[0].PlayURL;
                }
                return string.Empty;
            }
            catch (Exception ex)
            {
                return string.Empty;
                throw;
            }
        }
        public Dictionary<string, string> GetVideoDefinition(string strVid)
        {
            try
            {
                GetPlayInfoRequest request = new GetPlayInfoRequest();
                Dictionary<string, string> dic = new Dictionary<string, string>();
                string strAliVid = strVid;//this.GetAliVid(strVid);
                if (string.IsNullOrEmpty(strAliVid))
                {
                    return null;
                }
                request.VideoId = strAliVid;
                
                GetPlayInfoResponse response = acsClient.GetAcsResponse(request);
                List<GetPlayInfoResponse.GetPlayInfo_PlayInfo> playInfoList = response.PlayInfoList;
                if (playInfoList.Count > 0)
                {
                    foreach (GetPlayInfoResponse.GetPlayInfo_PlayInfo item in playInfoList)
                    {
                        dic.Add(item.Definition, item.PlayURL);
                    }
                }
                return dic;
            }
            catch (Exception ex)
            {
                return null;
                throw;
            }
        }
        public Dictionary<string, string> GetHRVideoDefinition(string strVid)
        {
            try
            {
                GetPlayInfoRequest request = new GetPlayInfoRequest();
                Dictionary<string, string> dic = new Dictionary<string, string>();
                request.VideoId = strVid;
                
                GetPlayInfoResponse response = acsClient.GetAcsResponse(request);
                List<GetPlayInfoResponse.GetPlayInfo_PlayInfo> playInfoList = response.PlayInfoList;
                if (playInfoList.Count > 0)
                {
                    foreach (GetPlayInfoResponse.GetPlayInfo_PlayInfo item in playInfoList)
                    {
                        dic.Add(item.Definition, item.PlayURL);
                    }
                }
                return dic;
            }
            catch (Exception ex)
            {
                return null;
                throw;
            }
        }

        public string GetVideoPlayAuth(string strVid)
        {
            try
            {
                GetVideoPlayAuthRequest request = new GetVideoPlayAuthRequest();
                string strAliVid = strVid;//this.GetAliVid(strVid);
                if (string.IsNullOrEmpty(strAliVid))
                {
                    return string.Empty;
                }
                request.VideoId = strAliVid;
                
                GetVideoPlayAuthResponse response = acsClient.GetAcsResponse(request);
                string strPlayAuth = response.PlayAuth;
                if (string.IsNullOrEmpty(strPlayAuth))
                {
                    return string.Empty;
                }
                return strPlayAuth;
            }
            catch (Exception ex)
            {
                return string.Empty;
                throw;
            }
        }

        public string GetHRVideoPlayAuth(string strVid)
        {
            try
            {
                GetVideoPlayAuthRequest request = new GetVideoPlayAuthRequest();
                request.VideoId = strVid;
                
                GetVideoPlayAuthResponse response = acsClient.GetAcsResponse(request);
                string strPlayAuth = response.PlayAuth;
                if (string.IsNullOrEmpty(strPlayAuth))
                {
                    return string.Empty;
                }
                return strPlayAuth;
            }
            catch (Exception ex)
            {
                return string.Empty;
                throw;
            }
        }

        public bool RefreshUploadVideo(string strVid)
        {
            RefreshUploadVideoRequest request = new RefreshUploadVideoRequest();
            request.VideoId = strVid;
            
            RefreshUploadVideoResponse response = acsClient.GetAcsResponse(request);
            return true;
        }

        #endregion

        #region 客户端方法

        public static void UploadVideo(VideoRequest videoRequest) 
        {
            JObject uploadAddress = JObject.Parse(videoRequest.UploadAddress);
            JObject uploadAuth = JObject.Parse(videoRequest.UploadAuth);

            var endpoint = uploadAddress["Endpoint"].ToString();
            var accessKeyId = uploadAuth["AccessKeyId"].ToString();
            var accessKeySecret = uploadAuth["AccessKeySecret"].ToString();
            var bucketName = uploadAddress["Bucket"].ToString();
            var stsToken = uploadAuth["SecurityToken"].ToString();
            var objectName = uploadAddress["FileName"].ToString();
            var localFilename = videoRequest.LocalFilePath;
            string checkpointDir = $"{Application.StartupPath}checkpoint";
            if (!Directory.Exists(checkpointDir)) 
            {
                Directory.CreateDirectory(checkpointDir);
            }

            var client = new OssClient(endpoint, accessKeyId, accessKeySecret,stsToken);
            try
            {
                // 通过UploadFileRequest设置多个参数。
                UploadObjectRequest request = new UploadObjectRequest(bucketName, objectName, localFilename)
                {
                    // 指定上传的分片大小。
                    PartSize = 8 * 1024 * 1024,
                    // 指定并发线程数。
                    ParallelThreadCount = 3,
                    // checkpointDir保存断点续传的中间状态，用于失败后继续上传。如果checkpointDir为null，断点续传功能不会生效，每次失败后都会重新上传。
                    CheckpointDir = checkpointDir,
                };
                // 断点续传上传。
                client.ResumableUploadObject(request);
                Console.WriteLine("Resumable upload object:{0} succeeded", objectName);
            }
            catch (OssException ex)
            {
                Console.WriteLine("Failed with error code: {0}; Error info: {1}. \nRequestID:{2}\tHostID:{3}",
                    ex.ErrorCode, ex.Message, ex.RequestId, ex.HostId);
            }
            catch (Exception ex)
            {
                Console.WriteLine("Failed with error info: {0}", ex.Message);
            }
        }

        #endregion

        #region 公共方法

        public static string Base64Encode(string plainText)
        {
            var plainTextBytes = Encoding.UTF8.GetBytes(plainText);
            return Convert.ToBase64String(plainTextBytes);
        }

        public static string Base64Decode(string base64EncodedData)
        {
            var base64EncodedBytes = Convert.FromBase64String(base64EncodedData);
            return Encoding.UTF8.GetString(base64EncodedBytes);
        }


        #endregion
    }

    public class VideoRequest
    {

        public string RequestId { get; set; }

        public string UploadAddress { get; set; }

        public string UploadAuth { get; set; }

        public string VideoId { get; set; }

        public int ClassId { get; set; }

        public string LocalFilePath { get; set; }
    }
}
